/*
 * Copyright (c) 2010 LAAS/CNRS                       --  Oct 2010
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */
/*------------------------------------------------------------
 * 
 *                     --  Module  LWR  --
 * 
 *  Description:
 *  Creation date : Wed May 19 22:35:29 2010 
 *  Author: Xavier Broquere
 *  LAAS-CNRS, Toulouse FRANCE
 *------------------------------------------------------------*/

#ifndef LWR_FUNCTION_STRUCT_H
#define LWR_FUNCTION_STRUCT_H

#include "genManipStruct.h"

typedef struct LWR_MOTION_STR {
  LWR_MOTION_TYPE_ENUM  type;
  LWR_MOTION_STATE_ENUM state;
  LWR_MOTION_ERROR_ENUM error;

  double duration;
  double curTime;
  SM_COND timeScaleCond;
  int trajId;
  SM_TRAJ traj;

  // Per-joint and cartesian velocity, acceleration and jerk limits
  double q_J_max[2*LWR_JOINTS];
  double q_A_max[2*LWR_JOINTS];
  double q_V_max[2*LWR_JOINTS];
  double x_J_max[2*LWR_SM_CART_COORDS];
  double x_A_max[2*LWR_SM_CART_COORDS];
  double x_V_max[2*LWR_SM_CART_COORDS];

  // only for executing traj from file ....
  int sample;
  int samplesNb;
  double t            [LWR_SM_MAX_SAMPLES];
  int lp              [LWR_SM_MAX_SAMPLES];
  Gb_q7 armLeft[LWR_SM_MAX_SAMPLES];
  Gb_q7 armRight[LWR_SM_MAX_SAMPLES];
  GENMANIP_POSITION_SAHAND_STR handLeft[LWR_SM_MAX_SAMPLES];
  GENMANIP_POSITION_SAHAND_STR handRight[LWR_SM_MAX_SAMPLES];



} LWR_MOTION_STR;

#endif
